using System;
using System.Runtime.InteropServices;

namespace ADS
{
	public class Tools
	{
		private const int ERROR_ALREADY_EXISTS = 183;

		[DllImport("coredll.dll", EntryPoint="GetLastError")]
		private static extern int GetLastError();

		[DllImport("coredll.dll", EntryPoint="CreateMutexW")]
		private static extern int CreateMutex(IntPtr lpMutexAttributes, bool InitialOwner, string MutexName);		

		public static bool IsInstanceRunning()
		{	

			string appname = System.Reflection.Assembly.GetExecutingAssembly().GetName().Name;
			
			if(CreateMutex(IntPtr.Zero, true, appname) != 0)
			{
				if(GetLastError() == ERROR_ALREADY_EXISTS)
				{
					return true;
				}
				else
				{
					return false;
				}
			}

			Debugging.DEBUGMSG(true, "CreateMutex failed!\r\n");
			return false;
		}
		[DllImport("coredll.dll")]
		private static extern int LoadCursor(int instance, int nCursorNum);
		
		[DllImport("coredll.dll")]private static extern int SetCursor(int nCursorNum);
		
		public static void WaitCursorOn()
		{  
			//Sets the waitcursor :  
			SetCursor(LoadCursor(0, 32514));
		}
		public static void WaitCursorOff()
		{  
			//Removes the waitcursor:  
			SetCursor(0);
		}
	}
}
