using System;

namespace ADS.MapPoint
{
	public class Address
	{
		private bool m_geocoded;
		private string m_name;
		private string m_street;
		private string m_city;
		private string m_state;
		private string m_zip;
		private CoordinateSet m_coordinates;

		public string Name
		{
			get
			{
				return m_name;
			}
			set
			{
				m_name = value;
			}
		}

		public string Street
		{
			get
			{
				return m_street;
			}
			set
			{
				m_street = value;
			}
		}

		public string City
		{
			get
			{
				return m_city;
			}
			set
			{
				m_city = value;
			}
		}

		public string State
		{
			get
			{
				return m_state;
			}
			set
			{
				m_state = value;
			}
		}

		public string Zip
		{
			get
			{
				return m_zip;
			}
			set
			{
				m_zip = value;
			}
		}

		public CoordinateSet Coordinates
		{
			get
			{
				return m_coordinates;
			}
			set
			{
				m_coordinates = value;
				m_geocoded = false;
			}
		}

		public double Latitude
		{
			get
			{
				return m_coordinates.Latitude;
			}
			set
			{
				m_coordinates.Latitude.FromDouble(value);
				m_geocoded = false;
			}
		}

		public double Longitude
		{
			get
			{
				return m_coordinates.Longitude;
			}
			set
			{
				m_coordinates.Longitude.FromDouble(value);
				m_geocoded = false;
			}
		}

		public bool Geocoded
		{
			get
			{
				return m_geocoded; 
			}
			set
			{
				m_geocoded = value;
			}
		}

		public Address() 
		{
			m_geocoded = false;
			m_coordinates = new CoordinateSet();
		}
	}
}
