using System;
using System.Net;
using TruckFinder.MapPointService;

namespace TruckFinder
{
	/// <summary>
	/// This class due in great part to work by Casey Chesnut
	/// </summary>
	public class RenderProxy
	{
		RenderServiceSoap RenderService = null;
		static public string UserName = "[user]";
		static public string Password = "[password]";

		public RenderProxy()
		{
			RenderService = new RenderServiceSoap();
			RenderService.Credentials = new NetworkCredential(UserName, Password);
		}

		public MapImage GetMap(string latPoint, string longPoint, int ImageHeight, int ImageWidth, int ZoomLevel, Pushpin location)
		{
			// Create and specify MapView object, set centerpoint and scale.
			MapView MapView = new MapView();
			MapView.CenterPoint = new LatLongCoord();
			MapView.CenterPoint.Latitude = System.Convert.ToDouble(latPoint);
			MapView.CenterPoint.Longitude = System.Convert.ToDouble(longPoint);
			MapView.Scale = ZoomLevel;

			// Create an array of MapView objects, insert previously created single MapView object.
			MapView[] MapViews = new MapView[1]; 
			MapViews[0] = MapView;

			// Create and specify MapOptions object, based on form and session data.
			MapOptions MapOptions = new MapOptions();
			MapOptions.Format = new ImageFormat();
			MapOptions.Format.Height = System.Convert.ToInt32(ImageHeight); 
			MapOptions.Format.Width = System.Convert.ToInt32(ImageWidth); 
			
			// Create an array of PushPin objects, store a single PushPin in element 0.
			Pushpin[] PushPins = new Pushpin[1];
			PushPins[0] = location;

			// Creating the MapImage object and actually rendering the map.
			MapImage[] MapImages = new MapImage[1];

			MapImages = RenderService.GetMap(MapViews, MapOptions, PushPins);

			return MapImages[0];
		}
	}
}
