using System;
using System.Collections;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Web;
using System.Web.SessionState;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.HtmlControls;
using TruckFinder.MapPointService;
using System.Net;
using System.Data.SqlClient;

namespace TruckFinder
{
	/// <summary>
	/// Summary description for ShowMap.
	/// </summary>
	public class ShowMap : System.Web.UI.Page
	{
		protected System.Data.SqlClient.SqlConnection cn;

		private void Page_Load(object sender, System.EventArgs e)
		{
			cn.Open();
			SqlParameter param = new SqlParameter();
			SqlCommand MapData = new SqlCommand("sp_GetLatLonSpeed", cn);
			MapData.CommandType = CommandType.StoredProcedure;

			param = MapData.Parameters.Add("@RecordID", SqlDbType.Int);
			param.Direction = ParameterDirection.Input;
			param.Value = Convert.ToInt32(Request.QueryString["ID"]);
			SqlDataReader sdr = MapData.ExecuteReader();
			if(sdr.Read())
			{
			
				double Latitude = (double)sdr.GetValue(0);
				double Longitude = (double)sdr.GetValue(1);

				MapImage mapImage = new MapImage();
				
				WebCartographer webCartographer = new WebCartographer();
				
				webCartographer.LastLocation.IconName = "Web";
				webCartographer.LastLocation.LatLong.Latitude = Latitude;
				webCartographer.LastLocation.LatLong.Longitude = Longitude;
				webCartographer.LastLocation.IconDataSource = "MapPoint.Icons";
				webCartographer.LastLocation.IconName = "0";
				webCartographer.LastLocation.PinID = "Web";
				webCartographer.LastLocation.Label = sdr.GetValue(2).ToString() + " mph";

				mapImage = webCartographer.GetMapImage(Latitude, Longitude, 10000);
				Response.ContentType = mapImage.Image.MIMEType;
				Response.BinaryWrite(mapImage.Image.Bits);
			}
			cn.Close();

		}

		#region Web Form Designer generated code
		override protected void OnInit(EventArgs e)
		{
			//
			// CODEGEN: This call is required by the ASP.NET Web Form Designer.
			//
			InitializeComponent();
			base.OnInit(e);
		}
		
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{    
			this.cn = new System.Data.SqlClient.SqlConnection();
			// 
			// cn
			// 
			this.cn.ConnectionString = "data source=DEVSERV;initial catalog=TruckTrack;persist security info=False;user i" +
				"d=sa;workstation id=DEVSERV;packet size=4096";
			this.Load += new System.EventHandler(this.Page_Load);

		}
		#endregion
	}
}
