using System;
using System.Collections;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Web;
using System.Web.SessionState;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.HtmlControls;
using TruckFinder.MapPointService;
using System.Net;
using System.IO;


namespace TruckFinder
{
	/// <summary>
	/// 
	/// </summary>
	public class WebMapping
	{
		// hold our location
		public Pushpin LastLocation;
		public string cachePath;

		public WebMapping()
		{
			LastLocation = new Pushpin();
			LastLocation.LatLong = new LatLongCoord();
		}


		public void SaveMapImage(double Latitude, double Longitude, int ImageHeight, int ImageWidth, int ZoomLevel, string FileName)
		{
			RenderProxy renderProxy = new RenderProxy();
			MapImage mapImage = new MapImage();

			try
			{
				mapImage = renderProxy.GetMap(Latitude.ToString(), Longitude.ToString(), ImageHeight, ImageWidth, ZoomLevel, LastLocation);
			}
			catch(Exception ex)
			{
				throw new Exception("GetMap failed!\r\n" + ex.Message);
			}
			if(mapImage.Image == null)
			{
				throw new Exception("MapImage.Image == null");
			}

			MIMEData mimeData = mapImage.Image;
		
			MapView mapView = mapImage.View;
			
			MemoryStream ms;

			ms = new MemoryStream(mimeData.Bits);

			FileStream fs = new FileStream(FileName, FileMode.Create);

			
			
			try
			{
				// first write header
				fs.Write(System.BitConverter.GetBytes(Latitude), 0, 8);
				fs.Write(System.BitConverter.GetBytes(Longitude), 0, 8);

				// next write image
				byte[] read = new byte[256];
				int count = ms.Read(read, 0, 256);

				while(count > 0) 
				{
					fs.Write(read, 0, count);
					count = ms.Read(read, 0, 256);
				}

				fs.Close();
				ms.Close();
			}
			catch(Exception)
			{
			}
		}

		public void DisplayMapImage(string FileName, System.Web.UI.WebControls.Image Destination, bool FileHasHeader)
		{
			Bitmap bitmap = null;

			if(FileHasHeader)
			{
				try
				{
					byte[] latlon = new Byte[16];
					byte[] img = new Byte[256];

					FileStream fsin = new FileStream(FileName, FileMode.Open, FileAccess.Read);
					FileStream fsout = new FileStream(cachePath + @"\temp.map", FileMode.Create);

					fsin.Read(latlon, 0, 16);
				
					// store is LastLocation
					LastLocation.LatLong.Latitude = System.BitConverter.ToDouble(latlon, 0);
					LastLocation.LatLong.Longitude = System.BitConverter.ToDouble(latlon, 8);

					int count = fsin.Read(img, 0, 256);

					while(count > 0)
					{
						fsout.Write(img, 0, count);
						count = fsin.Read(img, 0, 256);
					}
					fsin.Close();
					fsout.Close();
				}
				catch(Exception)
				{
				}

				FileName = cachePath + @"\temp.map";
			}
			
			try
			{
				bitmap = new Bitmap(FileName);
				Destination.ImageUrl = cachePath + @"\temp.map";
			}
			catch(Exception ex)
			{
				throw new Exception (ex.Message);
			}
		}
		
		public MapImage GetMapImage(double Latitude, double Longitude, int ZoomLevel)
		{	
			RenderProxy renderProxy = new RenderProxy();
			MapImage mapImage = new MapImage();

			try
			{
				mapImage = renderProxy.GetMap(Latitude.ToString(), Longitude.ToString(), 480, 640, ZoomLevel, LastLocation);
			}
			catch(Exception ex)
			{
				throw new Exception("GetMap failed!\r\n" + ex.Message);
			}
			if(mapImage.Image == null)
			{
				throw new Exception("MapImage.Image == null");
			}
			
			return mapImage;
		}	
	}
}
