using System;
using System.Data;

namespace TruckTrack
{
	/// <summary>
	/// Summary description for MyAddress.
	/// </summary>
	public class MapAddress
	{
		public struct Coordinate
		{
			public int Degrees;
			public int Minutes;
			public float Seconds;
			public string Direction;
		}
		
		private bool m_geocoded;
		private string m_name;
		private string m_street;
		private string m_city;
		private string m_state;
		private string m_zip;
		private double m_latitude;
		private double m_longitude;

		public string Name
		{
			get
			{
				return m_name;
			}
			set
			{
				m_name = value;
			}
		}

		public string Street
		{
			get
			{
				return m_street;
			}
			set
			{
				m_street = value;
			}
		}

		public string City
		{
			get
			{
				return m_city;
			}
			set
			{
				m_city = value;
			}
		}

		public string State
		{
			get
			{
				return m_state;
			}
			set
			{
				m_state = value;
			}
		}

		public string Zip
		{
			get
			{
				return m_zip;
			}
			set
			{
				m_zip = value;
			}
		}

		public double Latitude
		{
			get
			{
				return m_latitude;
			}
			set
			{
				m_latitude = value;
			}
		}

		public double Longitude
		{
			get
			{
				return m_longitude;
			}
			set
			{
				m_longitude = value;
			}
		}


		public Coordinate LatCoord
		{
			get
			{
				Coordinate c;
				float mins;
				c.Degrees = (int)Math.Floor(Math.Abs(m_latitude));
				mins = (float)(Math.Abs(m_latitude) - c.Degrees) * 60;
				c.Minutes = (int)Math.Floor(mins);
				c.Seconds = (float)(mins - c.Minutes) * 60;
				
				c.Direction = m_latitude >= 0 ? "N" : "S";

				return c;
			}
		}

		public Coordinate LonCoord
		{
			get
			{
				Coordinate c;
				float mins;
				c.Degrees = (int)Math.Floor(Math.Abs(m_longitude));
				mins = (float)(Math.Abs(m_longitude) - c.Degrees) * 60;
				c.Minutes = (int)Math.Floor(mins);
				c.Seconds = (float)(mins - c.Minutes) * 60;
				
				c.Direction = m_longitude >= 0 ? "E" : "W";

				return c;
			}
		}

		public bool Geocoded
		{
			get
			{
				return m_geocoded;
			}
			set
			{
				m_geocoded = value;
			}
		}

		public MapAddress() 
		{
			m_geocoded = false;
		}
	}
}
